package blatt8vorlage;

public class Main {

	
	public static void main(String[] args) {
		if (args.length < 1) {
			throw new IllegalArgumentException();
		}
		String text = args[0];
		String[] patternArray = args.length >= 2 ? args[1].split(",") : new String[]{};
		
		boolean verbose = true; // if false, the active nodes are not printed
		
		// build the tree
		SuffixTree st = new SuffixTree(text, verbose);
		
		// print the newick string
		System.out.println(st.toNewickString());
		
		// search for the patterns
		for (String pattern: patternArray) {
			System.out.println(st.contains(pattern));
		}
		
	}
}
