package blatt8vorlage;

public class SuffixTree {

	private Node superRoot, root;
	private String text;
	private boolean verbose;

	public SuffixTree(String text, boolean verbose) {
		this.text = text;
		this.verbose = verbose;
		initTree();
		buildTree();
	}
	
	public SuffixTree(String text) {
		this(text, false);
	}

	public Node getRoot() {
		return root;
	}

	public String toNewickString() {
		return root.toNewick(text);
	}
	
	/**
	 * Checks, if the text contains a given pattern in O(m) time, whereby m is the length of the pattern.
	 * @return true, if the text contains the pattern
	 */
	public boolean contains(String pattern) {
		return false;
		// TODO
	}
	
	/**
	 * Initialize the root and superRoot
	 */
	private void initTree() {
		superRoot = new Node(null, 0, -1, true, false);
		root = new Node(superRoot, -1, -1, false, true);
		superRoot.addRoot(root);
		root.setSuffixLink(superRoot);
	}
	
	/**
	 * Build the tree
	 */
	private void buildTree() {
		root.addChild(new Node(root, 0), text);
		Reference r = new Reference(root, 1, 0);
		for (int i = 1; i < text.length(); i++) {
			r.setEnd(i-1);
			update(r, i);
		}
	}
	
	private void update(Reference r, int i) {
		r.canonize(text);
		if (verbose) {
			// print the active node
			System.out.println("t_" + (i+1) + "=" + text.charAt(i) + ": (s,(t_k...t_p))=(" + r.getNode().getNodeString(text) + "," + r.getSubstring(text) + ")");
		}
		// TODO
	}
	
	private Pair<Boolean, Node> testAndSplit(Reference r, char x) {
		// TODO
		return null;
	}
	
	

}